﻿
using System;
using System.ComponentModel;
namespace InfragisticsTest
{
  public class Person
  {
    public String FirstName { get; set; }
    public String LastName { get; set; }
    public PersonList ParentList { get; set; }

  }

  public class Parent : Person,INotifyPropertyChanged
  {

    public PersonList Children { get; set; }
   
    public event PropertyChangedEventHandler PropertyChanged;
    
    public Parent(Person p)
    {
      
      FirstName = p.FirstName;
      LastName = p.LastName;
      p.ParentList.Add(this);
      p.ParentList.Remove(p);
      Children = new PersonList();
      ParentList = p.ParentList;
    }
  

    public void FirePropChanged()
    {
      if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs("Children"));
    }


  }
}
