using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace InfragisticsTest
{
  public class PersonList:List<Person>, ITypedList,IBindingList
  {
    public static int Depth=0;
    public string GetListName(PropertyDescriptor[] listAccessors)
    {
      return "DataList";
    }


    public void FireListChanged(PersonList list_)
    {
      if(Program.MainForm.InvokeRequired)
      {
        Program.MainForm.Invoke(new Action<PersonList>(FireListChanged),list_);
        return;
      }
      if (ListChanged != null)
      {
        ListChanged(this, new ListChangedEventArgs(ListChangedType.PropertyDescriptorDeleted, -1));
        ListChanged(this, new ListChangedEventArgs(ListChangedType.Reset, -1));
        /*ListChanged(list_, new ListChangedEventArgs(ListChangedType.PropertyDescriptorChanged, -1));
        ListChanged(list_, new ListChangedEventArgs(ListChangedType.PropertyDescriptorAdded, -1));
        ListChanged(list_, new ListChangedEventArgs(ListChangedType.Reset, -1));*/
      }
    }


    public void FireListAdded(PersonList list_)
    {
      if (Program.MainForm.InvokeRequired)
      {
        Program.MainForm.Invoke(new Action<PersonList>(FireListChanged), list_);
        return;
      }
      if (ListChanged != null)
      {

        ListChanged(this, new ListChangedEventArgs(ListChangedType.PropertyDescriptorAdded, -1));
        ListChanged(this, new ListChangedEventArgs(ListChangedType.Reset, -1));
      }
    }




   
    private PropertyDescriptorCollection Props(bool parent)
    {
      var collection = new PropertyDescriptorCollection(
        new PropertyDescriptor[]
          {
            new DataPropertyDescriptor("First Name"),
            new DataPropertyDescriptor("Last Name"),  
          });

      if (parent)
      {
        collection.Add(new DataPropertyDescriptor("Children"));
      }

      return collection;
    }

    public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors)
    {
      if (listAccessors == null && Depth == 0 || (listAccessors!=null)&&listAccessors.Length >= Depth)
      {
        return Props(false);
      }
      return Props(true);
    }

    public object AddNew()
    {
      throw new NotImplementedException();
    }

    public void AddIndex(PropertyDescriptor property)
    {
      throw new NotImplementedException();
    }

    public void ApplySort(PropertyDescriptor property, ListSortDirection direction)
    {
      throw new NotImplementedException();
    }

    public int Find(PropertyDescriptor property, object key)
    {
      throw new NotImplementedException();
    }

    public void RemoveIndex(PropertyDescriptor property)
    {
      throw new NotImplementedException();
    }

    public void RemoveSort()
    {
      throw new NotImplementedException();
    }

    public bool AllowNew
    {
      get { throw new NotImplementedException(); }
    }

    public bool AllowEdit
    {
      get { return false; }
    }

    public bool AllowRemove
    {
      get { throw new NotImplementedException(); }
    }

    public bool SupportsChangeNotification
    {
      get { return true; }
    }

    public bool SupportsSearching
    {
      get { return false; }
    }

    public bool SupportsSorting
    {
      get { return false; }
    }

    public bool IsSorted
    {
      get { throw new NotImplementedException(); }
    }

    public PropertyDescriptor SortProperty
    {
      get { throw new NotImplementedException(); }
    }

    public ListSortDirection SortDirection
    {
      get { throw new NotImplementedException(); }
    }

    public event ListChangedEventHandler ListChanged;
  }
}